#COPYRIGHT (c) 2007 shagon
#FILENAME:Sudoku_solver.py
#COMPILER:PythonWin
#DATE:Sep 15th,2007
#TESTED on my NOKIA6670

print "\n"
print "*********************"
print "** www.cnpda.com.cn **"
print "******  shagon  ******"
print "***** 2007.09.15 ******"
print "*********************\n"

num=[]
for x in range(100):
    num.append([])
    for y in range(10):
        num[x].append(0)
        
row=[0,11,12,13,14,15,16,17,18,19,21,22,23,24,25,26,27,28,29,31,32,33,34,35,36,37,38,39,41,42,43,44,45,46,47,48,49,51,52,53,54,55,56,57,58,59,61,62,63,64,65,66,67,68,69,71,72,73,74,75,76,77,78,79,81,82,83,84,85,86,87,88,89,91,92,93,94,95,96,97,98,99]
column=[0,11,21,31,41,51,61,71,81,91,12,22,32,42,52,62,72,82,92,13,23,33,43,53,63,73,83,93,14,24,34,44,54,64,74,84,94,15,25,35,45,55,65,75,85,95,16,26,36,46,56,66,76,86,96,17,27,37,47,57,67,77,87,97,18,28,38,48,58,68,78,88,98,19,29,39,49,59,69,79,89,99]
block=[0,11,12,13,21,22,23,31,32,33,14,15,16,24,25,26,34,35,36,17,18,19,27,28,29,37,38,39,41,42,43,51,52,53,61,62,63,44,45,46,54,55,56,64,65,66,47,48,49,57,58,59,67,68,69,71,72,73,81,82,83,91,92,93,74,75,76,84,85,86,94,95,96,77,78,79,87,88,89,97,98,99]

row_id=1
column_id=2
block_id=3

def new_confirm(pos):
    global num
    for seeking in range(1,10):
        if num[pos][seeking]==9:
            num[pos][1]=seeking
            break
    return

def repeat_check(array_id):
    global num,row,column,block,is_repeat
    if array_id==row_id:
        array=row
    elif array_id==column_id:
        array=column
    else:
        array=block
    for x in range(9):
        temp=x*9+1
        for y in range(temp,temp+8):
            if num[array[y]][0]<>1: continue
            for z in range(y+1,temp+9):
                if num[array[z]][0]<>1: continue
                if num[array[y]][1]==num[array[z]][1]:
                    is_repeat=1
                    return 
    return

def single_comf(array_id):
    global num,row,column,block,changed
    if array_id==row_id:
        array=row
    elif array_id==column_id:
        array=column
    else:
        array=block
    for x in range(9):
        temp=x*9+1
        for y in range(temp,temp+9):
            if num[array[y]][0]<>1: continue
            confirm=num[array[y]][1]
            for z in range(temp,temp+9):
                if num[array[z]][0]==1 or num[array[z]][confirm]==0: continue
                changed=1
                num[array[z]][confirm]=0
                num[array[z]][0]=num[array[z]][0]-1
                if num[array[z]][0]==1:
                    new_confirm(array[z])
    return

def display():
    global num
    print "The solution is:"
    result=" "
    for x in range(11,101):
        if x%10==0:
            print result
            result=" "
            continue
        result=result+"["+str(num[x][1])+"]"
    return

def done_check():
    global num
    is_done=1
    for x in range(11,100):
        if x%10==0: continue
        if num[x][0]<>1:
            is_done=0
            break
    return is_done




while 1:    
    for x in range(11,100):
        for y in range(10):
            num[x][y]=9            
    sudoku=" "    
    while 1:
        for i in range(1,10):  
            while 1:
                sudoku=raw_input("Enter Row "+str(i)+": ")
                right=1
                if len(sudoku)<>9: right=0
                else:
                    for x in range(len(sudoku)):
                        if sudoku[x]<"0" or sudoku[x]>"9":
                            if sudoku[x]<>" ":
                                right=0
                                break
                if right==1:
                    break
                else:
                    print "Enter Error!"
            for x in range(9):
                if sudoku[x]<>" " and sudoku[x]<>"0":
                    num[i*10+x+1][0]=1
                    num[i*10+x+1][1]=int(sudoku[x])
                    
        is_repeat=0
        repeat_check(row_id)
        if is_repeat==1:
            print "Sudoku puzzle creation wrong!"
        else:
            repeat_check(column_id)
            if is_repeat==1:
                print "Sudoku puzzle creation wrong!"
            else:
                repeat_check(block_id)
                if is_repeat==1:
                    print "Sudoku puzzle creation wrong!"
                else:
                    break
      
    while 1:
        changed=0 
        single_comf(row_id)
        single_comf(column_id)
        single_comf(block_id)
        if changed==0: break
    if done_check()==1:
        display()
    else:
        print "Can not solve it."
    

    
    restart=raw_input("Another?(0:exit) ")
    if restart==str(0):
        print "\n"
        print "Written by shagon"
        print "Shagon's Fifth Python-programming"
        break 